/*
 * RFM12B.c
 *
 *  Created on: 19-02-2014
 *      Author: Piotr Rzeszut
 *  
 * Description: Funkcje do obsugi ukadu RFM12B z poziomu procesora AVR
 */
#include "RFM12B.h"

void Rfm_spi_init(void){
	SPI_DDR |= (1<<SPI_SCK)|(1<<SPI_MOSI)|(1<<SPI_SS);//konfiguracja kierunku i podcigania linii SPI
	SPI_PORT |= (1<<SPI_MISO);
	//do poprawnej pracy moduu SPI w procesorze linia SS musi by ustawiona jako wyjcie

	SPCR |= (1<<SPE)|(1<<MSTR)|(1<<SPR0);//SPI w trybie master z podziaem zegara przez 64 
	

	CS_PORT |= (1<<CS_RFM);//dezaktywacja ukadu RFM12B
	CS_DDR |= (1<<CS_RFM);//konfiguracja kierunku linii CS
}

uint16_t Rfm_xmit(uint16_t data){
	//na pocztek rodzielamy dane na 2 bajty
	uint8_t msb, lsb;
	lsb = data;
	msb = data>>8;
	CS_PORT &= ~(1<<CS_RFM);//aktywujemy lini CS ukadu
	//teraz wysyamy 2 bajty jednoczenie odbierajc 2 bajty z ukadu
	SPDR = msb;
	while(!(SPSR&(1<<7)));
	msb = SPDR;
	SPDR = lsb;
	while(!(SPSR&(1<<7)));
	lsb = SPDR;
	//_delay_ms(1);
	CS_PORT |= (1<<CS_RFM);//dezaktywujemy lini CS ukadu
	//i zwracamy odebrane dane
	return( (((uint16_t)msb)<<8)+((uint16_t)lsb) );
}
