/*
 * main.c
 *
 *  Created on: 19-02-2014
 *      Author: Piotr Rzeszut
 *  
 * Description: Przykad komunikacji z moduem RFM12B
 */
#include <avr/io.h>
#include <util/delay.h>
#include <string.h>
#include <stdio.h>
#include <avr/interrupt.h>

#include "RFM12B.h"
#include "uart.h"

char bufor[65];
uint16_t status;

int main(void){

	Rfm_spi_init();//inicjalizacja magistrali SPI
	uart_init(9600);//inicjalizacja USART
	sei();//wczamy przerwania do obsugi uart

	uart_puts("\r\n\r\nRFM12B - COMMUNICATION TEST\r\n");//wywietlamy powitanie
	
	Rfm_xmit(SW_RESET);//resetuj programowo ukad RFM12B
	
	uint16_t mask;
	
	do{//ptla...
		
		_delay_ms(250);//dajemy ukadowi nieco czasu na wykonanie polecenia
		status=Rfm_xmit(STATUS_READ);//odczytujemy rejestr statusu
		
		mask=0b1000000000000000;
		do{//ta ptla wywietla binarnie zawarto tego rejestru
			uart_putc((status&mask)?'1':'0');
			mask>>=1;
		}while(mask);
		
		uart_puts("\r\n");
		
	}while(!(status&M_POR));//...powtarzana dopki nie odczytamy ustawienia bitu sygnalizujcego poprawny reset
	uart_puts("POR detected\r\n");
	
	//po odczycie bit ten powinien zosta skasowany, wic dokonujemy kolejnego odczytu
	status=Rfm_xmit(STATUS_READ);
	
	
	mask=0b1000000000000000;
	do{//znowu wywietlamy zawarto
		uart_putc((status&mask)?'1':'0');
		mask>>=1;
	}while(mask);
	
	uart_puts("\r\n");
	
	//jeli bit nadal jest ustawiony to komunikacja jest bdna
	if(status&M_POR){
		uart_puts("TEST FAIL\r\n");
	}else{//w przeciwnym wypadku wszystko jest OK
		uart_puts("TEST PASS\r\n");
	}
	
	while(1);

	return 0;
}
